package com.engine.organization.service;

import com.engine.organization.entity.danikor.param.ChartParam;
import com.engine.organization.util.MenuBtn;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/01/17
 * @version: 1.0
 */
public interface DanikorResourceBackService {

    /**
     * 人员回溯列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 获取搜索条件
     *
     * @return
     */
    Map<String, Object> getSearchCondition();

    /**
     * 获取列表页面按钮信息
     *
     * @return
     */
    Map<String, List<MenuBtn>> getHasRight();

    /**
     * 获取汇总数据
     *
     * @param params
     * @return
     */
    Map<String, Object> getSummaryData(Map<String, Object> params);

    /**
     * 组织架构图
     *
     * @param params
     * @return
     */
    String getOrgChartData(HttpServletRequest request, Map<String, Object> params);

    List<ChartParam> getOrgChartData(Map<String, Object> params);

    /**
     * 人员架构图
     *
     * @param params
     * @return
     */
    List<ChartParam> getResourceChartData(Map<String, Object> params);
}
